import type { ConnectDragSource, ConnectDragPreview } from '../../types';
import type { DragSourceHookSpec, FactoryOrInstance } from '../types.js';
import { Ref } from 'vue';
/**
 * useDragSource hook
 * @param specArg The drag source specification (object or function, function preferred)
 */
export declare function useDrag<DragObject = unknown, DropResult = unknown, CollectedProps = unknown, ConnectDragSourceOptions = unknown, ConnectDragPreviewOption = unknown>(specArg: FactoryOrInstance<DragSourceHookSpec<DragObject, DropResult, CollectedProps>>): [
    Ref<CollectedProps>,
    Ref<ConnectDragSource<ConnectDragSourceOptions>>,
    Ref<ConnectDragPreview<ConnectDragPreviewOption>>
];
